/*
 * Sixth 3D engine demos. Author: Svjatoslav Agejenko. 
 * This project is released under Creative Commons Zero (CC0) license.
 *
*/

package eu.svjatoslav.sixth.e3d.examples.launcher;

import javax.swing.*;
import java.awt.*;


class Main {

    public static void main(final String[] args) {
        buildAndShowGuiWindow();
    }

    /**
     * Builds and shows the main window of the application.
     */
    private static void buildAndShowGuiWindow() {
        JFrame frame = new JFrame("Sixth 3D engine demos");

        // Keep application running until last frame is closed.
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

        frame.getContentPane().setLayout(new BorderLayout());
        frame.getContentPane().add(new ApplicationListPanel(), BorderLayout.CENTER);
        frame.setSize(400, 300);

        frame.setLocationRelativeTo(null); // center frame on screen
        frame.setVisible(true);
    }

}
